#pragma once
#pragma warning(disable : 4996) // Â֐̎gpɑ΂x}

#include <sphelper.h>

#define WM_REC_EVENT   WM_USER + 0  // FbZ[W
#define WORD_MAX_SIZE  0xFF         // Fʂ̌̍őTCY

namespace SAPI
{
    // GW
    class SpeechEngine
    {
    // Construction --------------------------------------------------------
    public:
        SpeechEngine();
        ~SpeechEngine();

    // Operation -----------------------------------------------------------
    public:
        void Init( HWND hWnd, const wchar_t* grammarFile );

        int GetRecognitionEvent();

        BOOL GetRecognitionResult( wchar_t* text );
        BOOL GetRecognizedPronunciation( wchar_t* text );

        BOOL GetConfidence( double& value );
        const wchar_t* GetState( int eventID );

    private:
        void InitMicrophone( CComPtr< ISpRecognizer > &recognizer );
        void InitGrammar( wchar_t const* grammarFile );

    // Attribute ===========================================================
    private:
        CComPtr< ISpRecoContext > m_recoContext;    // FReLXg
        CComPtr< ISpRecoGrammar > m_recoGrammar;    // fBNe[V@

        CSpEvent m_spEvent;     // SAPICxg
    };
}